image: python:3.6

before_script:
  - python --version
  - pip install -r requirements.txt

stages:
  - Info
  - Code Analysis
  - Test

info:
  stage: Info
  script:
    - pwd
    - whoami
    - which python
    - which pip

pylint:
  stage: Code Analysis
  allow_failure: true
  script:
    - pip install pylint
    - pylint -d C0301,R0902,E0611,E0401,C0413,R0201 ./pyAmakCore/classes --max-parents=9

flake8:
  stage: Code Analysis
  allow_failure: true
  script:
    - pip install flake8
    - flake8 --verbose --max-line-length=120 --max-complexity 8 ./pyAmakCore/classes

isort:
  stage: Code Analysis
  allow_failure: true
  script:
    - pip install isort
    - isort .

pytest:
  stage: Test
  script:
    - pip install pytest pytest-cov coverage-badge
    - pip install pytest-timeout
    - pytest -v --cov=pyAmakCore/classes --cov=pyAmakCore/exception --cov=pyAmakCore/enumeration --junitxml=report.xml --timeout=300
    - coverage report -m
  artifacts:
    when: always
    reports:
      junit: report.xml
      cobertura: coverage.xml

mutation:
  stage: Test
  allow_failure: true
  script:
    - pip install pytest pytest-cov coverage-badge
    - pip install pytest-timeout
    - pip install mutmut
    - mutmut run
  artifacts:
    when: always
    paths:
      - .mutmut-cache
